=== debian/changelog ===
xmlrpc-c (1.59.03-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix gcc15 build (Closes: #1098155)

 -- Victor Seva <vseva@debian.org>  Thu, 11 Sep 2025 11:44:24 +0200

xmlrpc-c (1.59.03-10) unstable; urgency=medium

  * Depends on external libexpat1-dev (Closes: #1104753)
  * Reinstate hardening patch, fix blhc job on Salsa

 -- Alexandre Detiste <tchet@debian.org>  Sat, 17 May 2025 14:32:20 +0200

xmlrpc-c (1.59.03-9) unstable; urgency=high

  * Expand libexpat1 patch to also update xmlrpc-c-config &
    the pkg-config snippet. (Closes: #1104366, #1104362)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 02 May 2025 16:37:03 +0200

xmlrpc-c (1.59.03-8) unstable; urgency=medium

  * Use system libexpat1 instead of old vendored libexpat (Closes: #1102554)
  * Drop kfreebsd patch

 -- Alexandre Detiste <tchet@debian.org>  Sat, 19 Apr 2025 12:48:36 +0200

xmlrpc-c (1.59.03-7) unstable; urgency=medium

  * Rewrite d/copyright in machine-parsable format

 -- Alexandre Detiste <tchet@debian.org>  Sun, 16 Mar 2025 23:03:22 +0100

xmlrpc-c (1.59.03-6) unstable; urgency=medium

  [ Yegor Yefremov ]
  * Backport pkg-config patch from 1.6x.x branch (Closes: #1086167)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 08 Nov 2024 13:15:48 +0100

xmlrpc-c (1.59.03-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Update variable name for build architecture compiler.
    (Closes: #1084809)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 16 Oct 2024 18:19:19 +0200

xmlrpc-c (1.59.03-4) unstable; urgency=medium

  * Add a the libxmlrpc-core-c3-dev -> libxmlrpc-util-dev
    dependency (Closes: #1072163)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 31 May 2024 12:37:13 +0200

xmlrpc-c (1.59.03-3) unstable; urgency=medium

  * add 'Replaces:' (Closes: #1071735)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 25 May 2024 17:47:54 +0200

xmlrpc-c (1.59.03-2) unstable; urgency=medium

  * Split-out xmlrpc-utils4 (Closes: #1071465)
  * Apply Multi-Arch hint
  * Close old Ubuntu bugs: (LP: #464509, LP: #1865344)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 22 May 2024 10:14:45 +0200

xmlrpc-c (1.59.03-1) unstable; urgency=medium

  * Adopt package (Closes: #773435)
  * New upstream version 1.59.03 (Closes: #524550)
  * Switch to debhelper compat 13
  * Refresh patches
  * Bump soname for C++ lib, no reverse dep in Debian
  * Merge remaining time64 changes for C lib from the NMU
  * Provide .pc files for pkg-config (Closes: #614423)
  * LTO does work now (Closes: #1015709)
  * Pull in curl development package when installing
    xmlrpc devevelopement (Closes: #928702)

  [ Jörg Frings-Fürst ]
  * Work for new release
  * Imported Upstream version 1.33.15+svn20141226~2672
  * Imported Upstream version 1.33.17

 -- Alexandre Detiste <tchet@debian.org>  Fri, 10 May 2024 18:40:43 +0200

xmlrpc-c (1.33.14-12) unstable; urgency=medium

  * QA upload.
  * Fix extraneous X-Time64-Compat declarations.

 -- Steve Langasek <vorlon@debian.org>  Sun, 03 Mar 2024 21:26:20 +0000

xmlrpc-c (1.33.14-11.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063279

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 07:39:42 +0000

xmlrpc-c (1.33.14-11) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 13 Oct 2022 13:27:40 +0100

xmlrpc-c (1.33.14-10) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch:
    + Build-Depends: Drop versioned constraint on debhelper.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 22 Aug 2021 03:19:47 +0100
